//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <dir.h>
#include <jpeg.hpp>
#pragma hdrstop

#include "MainDlg.h"
#include "Calculate.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SHDocVw_OCX"
#pragma resource "*.dfm"

//------------------ Globals ---------------

TTestApp *TestApp;
char startUpDir[255];



//---------------------------------------------------------------------------
__fastcall TTestApp::TTestApp(TComponent* Owner)
        : TForm(Owner)
{
  char tmp[1024];
  FILE *fid;

  // Do init here
  TrackBar1->Position=50;
  sprintf(tmp, "%3d %", TrackBar1->Position);
  StaticText9->Caption=tmp;
  CheckBox3->Checked=True;
  sprintf(startUpDir, "%s", DirectoryListBox1->Directory);
  if (strlen(startUpDir) == 3)
  {
    /* Only drive name, remove \ after drive name: */
    startUpDir[2]=0;
  }
  strcpy(tmp, startUpDir);
  strcat(tmp, "\\APSPhoto.ini");

  if ((fid = fopen(tmp,"r")) != NULL)
  {
    int tmpint;
    // Ini file found, do init.
    CheckBox1->Checked=True;
    CheckBox2->Checked=True;
    CheckBox3->Checked=True;

    fgets(tmp,1024,fid);
    if (strcmp(tmp,"[Picture formats]\n") != 0)
    {
      fclose(fid);
      MessageBox(NULL, "Error reading ini file", "Error reading ini file", MB_OK);
      return;
    }
    fgets(tmp, 1024, fid); tmp[strlen(tmp)-1] = 0; Edit1->Text=tmp;
    fgets(tmp, 1024, fid); tmp[strlen(tmp)-1] = 0; Edit2->Text=tmp;
    fgets(tmp, 1024, fid); tmp[strlen(tmp)-1] = 0; Edit3->Text=tmp;
    fgets(tmp, 1024, fid); tmp[strlen(tmp)-1] = 0; Edit4->Text=tmp;
    fgets(tmp, 1024, fid); tmp[strlen(tmp)-1] = 0; Edit5->Text=tmp;
    fgets(tmp, 1024, fid); tmp[strlen(tmp)-1] = 0; Edit6->Text=tmp;
    fgets(tmp, 1024, fid); tmp[strlen(tmp)-1] = 0; Edit7->Text=tmp;
    fgets(tmp, 1024, fid); tmp[strlen(tmp)-1] = 0; Edit8->Text=tmp;
    fgets(tmp,1024,fid);
    if (strcmp(tmp,"[JPEG Quality]\n") !=0 )
    {
      fclose(fid);
      MessageBox(NULL, "Error reading ini file", "Error reading ini file", MB_OK);
      return;
    }
    fscanf(fid,"%d\n",&tmpint);
    TrackBar1->Position=tmpint;
    fgets(tmp,1024,fid);
    if (strcmp(tmp,"[CheckBoxes]\n") !=0 )
    {
      fclose(fid);
      MessageBox(NULL, "Error reading ini file", "Error reading ini file", MB_OK);
      return;
    }
    fscanf(fid,"%d\n",&tmpint);
    CheckBox1->Checked=tmpint;
    fscanf(fid,"%d\n",&tmpint);
    CheckBox2->Checked=tmpint;
    fscanf(fid,"%d\n",&tmpint);
    CheckBox3->Checked=tmpint;
    fscanf(fid,"%d\n",&tmpint);
    CheckBox4->Checked=tmpint;
    fclose(fid);
  }

}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void __fastcall TTestApp::DriveComboBox1Change(TObject *Sender)
{
  DirectoryListBox1->Drive = DriveComboBox1->Drive;
}
//---------------------------------------------------------------------------

void __fastcall TTestApp::DirectoryListBox1Change(TObject *Sender)
{
  char tmpStr[256];
  DirectoryListBox1->OpenCurrent();

  sprintf(tmpStr, "%s", DirectoryListBox1->Directory);

// MessageBox(NULL, tmpStr, "Directory change", MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TTestApp::Button1Click(TObject *Sender)
{
  char dirStr[256];
  char outputDirStr[256];
  char fileStr[256];
  char totStr[256];
  int consPhoto[60];
  float aspectRatio[60];
  FILE *fid;
  FILE *fidtext;
  char title[256];
  char subTitle[256];
  int i, nrOfPictures;
  char indexWidth[20];
  char indexHeight[20];


  DirectoryListBox1->OpenCurrent();
  DirectoryListBox2->OpenCurrent();

  sprintf(dirStr, "%s", DirectoryListBox1->Directory);
  if (strlen(dirStr) == 3)
  {
    /* Only drive name, remove \ after drive name: */
    dirStr[2]=0;
  }

  sprintf(outputDirStr, "%s", DirectoryListBox2->Directory);
  if (strlen(outputDirStr) == 3)
  {
    /* Only drive name, remove \ after drive name: */
    outputDirStr[2]=0;
  }

  if (CheckBox4->Checked)
  {
    struct ffblk ffblk;
    char tmp[512];
    char dest[512];

    strcpy(tmp, startUpDir);
    strcat(tmp, "\\*.gif");
    if(findfirst(tmp,&ffblk,0)==0)
    {
      do
      {
        strcpy(fileStr, startUpDir);
        strcat(fileStr, "\\");
        strcat(fileStr, ffblk.ff_name);
        strcpy(dest, outputDirStr);
        strcat(dest, "\\");
        strcat(dest, ffblk.ff_name);
        CopyFile(fileStr, dest);
      } while(!findnext(&ffblk));
    }
    strcpy(tmp, startUpDir);
    strcat(tmp, "\\*.jpg");
    if(findfirst(tmp,&ffblk,0)==0)
    {
      do
      {
        strcpy(fileStr, startUpDir);
        strcat(fileStr, "\\");
        strcat(fileStr, ffblk.ff_name);
        strcpy(dest, outputDirStr);
        strcat(dest, "\\");
        strcat(dest, ffblk.ff_name);
        CopyFile(fileStr, dest);
      } while(!findnext(&ffblk));
    }
  }
  nrOfPictures=0;

  // Scan for available xx.jpg files
  for (i=0; i<60; i++)
  {
    sprintf(fileStr, "\\%02d.jpg", i);
    totStr[0]=0;
    strcat(totStr, dirStr);
    strcat(totStr, fileStr);
    if ((fid = fopen(totStr, "rb")) == NULL)
    {
    }
    else
    {
      consPhoto[nrOfPictures]=i;
      nrOfPictures++;
      fclose(fid);
    }
  }

  // Check whether xx.jpg's were found
  if (nrOfPictures == 0)
  {
    sprintf(totStr, "No photo's found in directory: %s.\nPhoto's should have filename 01.jpg, 02.jpg ... nn.jpg", DirectoryListBox1->Directory);

    MessageBox(NULL, totStr, "Error", MB_OK);
    return;
  }

  if ((strcmp(dirStr,outputDirStr)==0) &&
      (CheckBox2->Checked==False))
  {
    int ret;
    ret = MessageBox(NULL, "Input directory is same as output directory.\nOriginal JPEG's will be overwritten!\nSelect Cancel to abort or OK to continue\n", "Warning", MB_OKCANCEL);
    if (ret == IDCANCEL)
    {
      return;
    }
  }

  /////////////////////////////////
  // Generate HTML for every photo
  /////////////////////////////////
  // Open comment file if exists
  fileStr[0]=0;
  strcat(fileStr, dirStr);
  strcat(fileStr, "\\comment.txt");

  if ((fidtext = fopen(fileStr,"r")) == NULL)
  {
    strcat(fileStr, ".\nNo comments will be added to the photo's by replacing $(TEXT)....");
    MessageBox(NULL, fileStr, "Error opening:", MB_OK);
  }
  else
  {
    fgets(title, 256, fidtext);
    fgets(subTitle, 256, fidtext);
  }

  ProgressBar1->Min=0;
  ProgressBar1->Max=nrOfPictures;
  for (i=0; i<nrOfPictures; i++)
  {
    ProgressBar1->Position=i;
    sprintf(fileStr, "\\%02d.html", consPhoto[i]);
    totStr[0]=0;
    strcat(totStr, outputDirStr);
    strcat(totStr, fileStr);
    if ((fid = fopen(totStr, "wt")) == NULL)
    {
      MessageBox(NULL, totStr, "Error opening for writing:", MB_OK);
      return;
    }
    else
    {
      {
        FILE *fidorig;
        FILE *fidJPEG;
        char jpegFile[256];
        char tmp[1024];
        char textstr[1024];
        char widthString[10];
        char heightString[10];
        TJPEGImage *jp = new TJPEGImage();

        sprintf(jpegFile, "\\%02d.jpg", consPhoto[i]);
        totStr[0]=0;
        strcat(totStr, dirStr);
        strcat(totStr, jpegFile);
        jp->LoadFromFile(totStr);
        aspectRatio[i]=(float)(jp->Height)/(float)(jp->Width);
        delete jp;
        CalculateWidth(atoi(Edit1->Text.c_str()),
                       atoi(Edit2->Text.c_str()),
                       atoi(Edit3->Text.c_str()),
                       atoi(Edit4->Text.c_str()),
                       atoi(Edit5->Text.c_str()),
                       atoi(Edit6->Text.c_str()),
                       CheckBox1->Checked,
                       aspectRatio[i],
                       widthString);
        CalculateHeigth(atoi(Edit1->Text.c_str()),
                        atoi(Edit2->Text.c_str()),
                        atoi(Edit3->Text.c_str()),
                        atoi(Edit4->Text.c_str()),
                        atoi(Edit5->Text.c_str()),
                        atoi(Edit6->Text.c_str()),
                        CheckBox1->Checked,
                        aspectRatio[i],
                        heightString);
        {
          char outputJPEG[512];

          outputJPEG[0]=0;
          strcat(outputJPEG, outputDirStr);
          strcat(outputJPEG, jpegFile);

          ResizeJPEG(totStr,
                     outputJPEG,
                     atoi(widthString),
                     atoi(heightString),
                     TrackBar1->Position,
                     CheckBox2->Checked
                    );
        }

        tmp[0]=0;
        strcat(tmp, startUpDir);
        strcat(tmp, "\\demo.html");

        if ((fidorig = fopen(tmp,"r")) == NULL)
        {
          MessageBox(NULL, tmp, "Error opening:", MB_OK);
          return;
        }

        if (fidtext != NULL)
        {
          fgets(textstr, 1024, fidtext);
        }

        while (fgets(tmp, 1024, fidorig) != NULL)
        {
           char replaceString[256];

           while ((tmp[strlen(tmp)-1] == 10) ||
                  (tmp[strlen(tmp)-1] == 13) ||
                  (tmp[strlen(tmp)-1] == ' ')
                 )
           {
             tmp[strlen(tmp)-1]=0;
           }
           Replace(tmp, "$(WIDTH)", widthString);
           Replace(tmp, "$(HEIGHT)", heightString);
           sprintf(replaceString, "\"%02d.html\"", consPhoto[(i-1+nrOfPictures)%nrOfPictures]);
           Replace(tmp, "$(PREVIOUS)", replaceString);
           sprintf(replaceString, "\"%02d.jpg\"", consPhoto[i]);
           Replace(tmp, "$(NAME)", replaceString);
           sprintf(replaceString, "\"%02d.html\"", consPhoto[(i+1)%nrOfPictures]);
           Replace(tmp, "$(NEXT)", replaceString);
           sprintf(replaceString, "%02d", consPhoto[(i-1+nrOfPictures)%nrOfPictures]);
           Replace(tmp, "$(PREVIOUSNR)", replaceString);
           sprintf(replaceString, "%02d", consPhoto[i]);
           Replace(tmp, "$(CURRENTNR)", replaceString);
           sprintf(replaceString, "%02d", consPhoto[(i+1)%nrOfPictures]);
           Replace(tmp, "$(NEXTNR)", replaceString);
           Replace(tmp, "$(TEXT)", textstr);
           fprintf(fid, "%s\n", tmp);
        }
        fclose(fidorig);
      }
      fclose(fid);
    }
  }
  if (fidtext != NULL)
  {
    fclose(fidtext);
  }

  ///////////////////////////////////
  // Resize or copy the index.jpg  //
  ///////////////////////////////////
  {
    char outputIndex[512];
    char inputIndex[512];

    outputIndex[0]=0;
    strcat(outputIndex, outputDirStr);
    strcat(outputIndex, "\\index.jpg");

    inputIndex[0]=0;
    strcat(inputIndex, dirStr);
    strcat(inputIndex, "\\index.jpg");

    if ((fid=fopen(inputIndex, "r")) != NULL)
    {
      TJPEGImage *jp = new TJPEGImage();
      float aspectRat;
      int height, width;

      fclose(fid);
      jp->LoadFromFile(inputIndex);
      aspectRat=(float)(jp->Height)/(float)(jp->Width);
      delete jp;
      width = atoi(Edit8->Text.c_str());
      if (CheckBox3->Checked)
      {
        height = (int)(aspectRat*width+0.5f);
      }
      else
      {
        height = atoi(Edit7->Text.c_str());
      }
      sprintf(indexWidth, "%d", width);
      sprintf(indexHeight, "%d", height);
      ResizeJPEG(inputIndex,
                 outputIndex,
                 width,
                 height,
                 TrackBar1->Position,
                 CheckBox2->Checked
                );
    }
    else
    {
      strcat(inputIndex, "\nNo index will be generated...");
      MessageBox(NULL, inputIndex, "Error opening index JPEG:", MB_OK);
      ProgressBar1->Position=0;
      return;
    }
  }

  //////////////////////////
  // Generate index HTML  //
  //////////////////////////

  totStr[0]=0;
  strcat(totStr, outputDirStr);
  strcat(totStr, "\\index.html");
  if ((fid = fopen(totStr, "wt")) == NULL)
  {
    MessageBox(NULL, totStr, "Error opening for writing:", MB_OK);
    return;
  }

  {
    FILE *fidorig;
    char tmp[1024];

    tmp[0]=0;
    strcat(tmp, startUpDir);
    strcat(tmp, "\\index.html");

    if ((fidorig = fopen(tmp,"r")) == NULL)
    {
      MessageBox(NULL, tmp, "Error opening:", MB_OK);
      return;
    }

    // Open comment file if exists
    fileStr[0]=0;
    strcat(fileStr, dirStr);
    strcat(fileStr, "\\comment.txt");
    fidtext = fopen(fileStr,"r");

    if (fidtext != NULL)
    {
      fgets(title, 256, fidtext);
      fgets(subTitle, 256, fidtext);
    }

    while (fgets(tmp, 1024, fidorig) != NULL)
    {
      char inString[1024];

      while ((tmp[strlen(tmp)-1] == 10) ||
             (tmp[strlen(tmp)-1] == 13) ||
             (tmp[strlen(tmp)-1] == ' ')
            )
      {
        tmp[strlen(tmp)-1]=0;
      }
      Replace(tmp, "$(WIDTH)", indexWidth);
      Replace(tmp, "$(HEIGHT)", indexHeight);
      Replace(tmp, "$(TITLE)", title);
      Replace(tmp, "$(SUBTITLE)", subTitle);
      if (strcmp(tmp,"$(TEXT)") == 0)
      {
        if (fidtext != NULL)
        {
           i=0;
           while (fgets(inString, 1024, fidtext) !=NULL)
           {
             while ((inString[strlen(inString)-1] == 10) ||
                    (inString[strlen(inString)-1] == 13) ||
                    (inString[strlen(inString)-1] == ' ')
                   )
             {
               inString[strlen(inString)-1]=0;
             }
             if (i<nrOfPictures)
             {
               sprintf(tmp, "<A HREF=\"%02d.html\">%d</A>. ", consPhoto[i], consPhoto[i]);
               i++;
               strcat(tmp, inString);
               strcat(tmp, "<BR>");
               fprintf(fid, "%s\n", tmp);
             }
           }
           strcpy(tmp, "");
        }
        else
        {
          strcpy(tmp, "");
        }
      }
      if (strcmp(tmp,"$(REFERERS)") == 0)
      {
        for (i=0; i< nrOfPictures; i++)
        {
          sprintf(tmp, "<A HREF=\"%02d.html\">%d</A> ", consPhoto[i], consPhoto[i]);
          if (((i+1) == (nrOfPictures/2)) && (nrOfPictures > 25))
          {
            strcat(tmp, "<BR>");
          }
          fprintf(fid, "%s\n", tmp);
        }
        strcpy(tmp, "");
      }
      fprintf(fid, "%s\n", tmp);
    }
    fclose(fidorig);
    if (fidtext != NULL)
    {
      fclose(fidtext);
    }
  }
  fclose(fid);

  ProgressBar1->Position=nrOfPictures;
  MessageBox(NULL, "Generation of photo book successfull", "Successfull", MB_OK);
  ProgressBar1->Position=0;
}

//---------------------------------------------------------------------------
void __fastcall TTestApp::CheckBox1Click(TObject *Sender)
{
  static int edit2Value;
  static int edit4Value;
  static int edit6Value;
  char tempStr[255];

  if ((CheckBox1->Checked) == false)
  {
    Edit2->Enabled = true;
    sprintf(tempStr, "%d", edit2Value);
    Edit2->Text=tempStr;
    Edit4->Enabled = true;
    sprintf(tempStr, "%d", edit4Value);
    Edit4->Text=tempStr;
    Edit6->Enabled = true;
    sprintf(tempStr, "%d", edit6Value);
    Edit6->Text=tempStr;
  }
  else
  {
    edit2Value = Edit2->Text.ToInt();
    Edit2->Enabled = false;
    Edit2->Text = "Not Applicable";
    edit4Value = Edit4->Text.ToInt();
    Edit4->Enabled = false;
    Edit4->Text = "Not Applicable";
    edit6Value = Edit6->Text.ToInt();
    Edit6->Enabled = false;
    Edit6->Text = "Not Applicable";
  }
}
//---------------------------------------------------------------------------





// Calculation of the pixels based on panorama pixel height

void __fastcall TTestApp::Button2Click(TObject *Sender)
{
   int temp;
   char tempStr[255];

   temp = Edit5->Text.ToInt();
   sprintf(tempStr, "%d", temp);
   Edit3->Text=tempStr;
   Edit1->Text=tempStr;
   if ((CheckBox3->Checked) == false)
   {
     Edit7->Text=tempStr;
   }
   sprintf(tempStr, "%d", (int)(temp*1.8f+0.5f));
   Edit8->Text=tempStr;
   if ((CheckBox1->Checked) == false)
   {
     sprintf(tempStr, "%d", (int)(temp*2.5f+0.5f));
     Edit2->Text=tempStr;
     sprintf(tempStr, "%d", (int)(temp*1.8f+0.5f));
     Edit4->Text=tempStr;
     sprintf(tempStr, "%d", (int)(temp*1.5f+0.5f));
     Edit6->Text=tempStr;
   }

}
//---------------------------------------------------------------------------




void __fastcall TTestApp::DriveComboBox2Change(TObject *Sender)
{
  DirectoryListBox2->Drive = DriveComboBox2->Drive;
}
//---------------------------------------------------------------------------



void __fastcall TTestApp::TrackBar1Change(TObject *Sender)
{
  char temp[10];
  sprintf(temp, "%3d %", TrackBar1->Position);
  StaticText9->Caption=temp;
}
//---------------------------------------------------------------------------

void __fastcall TTestApp::CheckBox2Click(TObject *Sender)
{
  static int trackbarPos=0;

  if (CheckBox2->Checked == True)
  {
    trackbarPos=TrackBar1->Position;
    TrackBar1->Position=100;
    TrackBar1->Enabled=False;
    StaticText9->Caption="N/A";
  }
  else
  {
    TrackBar1->Position=trackbarPos;
    TrackBar1->Enabled=True;
  }
}
//---------------------------------------------------------------------------

void __fastcall TTestApp::CheckBox3Click(TObject *Sender)
{
  static int edit7Value;
  char tempStr[255];

  if ((CheckBox3->Checked) == false)
  {
    Edit7->Enabled = true;
    sprintf(tempStr, "%d", edit7Value);
    Edit7->Text=tempStr;
  }
  else
  {
    edit7Value = Edit7->Text.ToInt();
    Edit7->Enabled = false;
    Edit7->Text = "Not Applicable";
  }
}
//---------------------------------------------------------------------------



void __fastcall TTestApp::AboutClick(TObject *Sender)
{
  MessageBox(NULL, "APS HTML Photo Album 1.0\nby Johan Meuwissen\nVisit: http://connect.to/saratoga\nor mail to: saratoga@connect.to\n\nAPS HTML Photo Album 1.0 is FREEWARE", "About APS HTML Photo Album", MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TTestApp::SaveSettingsClick(TObject *Sender)
{
  FILE *fid;
  char tmp[1024];

  strcpy(tmp, startUpDir);
  strcat(tmp, "\\APSPhoto.ini");

  if ((fid = fopen(tmp,"w")) == NULL)
  {
    MessageBox(NULL, tmp, "Error opening for writing:", MB_OK);
    return;
  }

  fprintf(fid,"[Picture formats]\n");
  fprintf(fid,"%s\n",Edit1->Text);
  fprintf(fid,"%s\n",Edit2->Text);
  fprintf(fid,"%s\n",Edit3->Text);
  fprintf(fid,"%s\n",Edit4->Text);
  fprintf(fid,"%s\n",Edit5->Text);
  fprintf(fid,"%s\n",Edit6->Text);
  fprintf(fid,"%s\n",Edit7->Text);
  fprintf(fid,"%s\n",Edit8->Text);
  fprintf(fid,"[JPEG Quality]\n");
  fprintf(fid,"%d\n",TrackBar1->Position);
  fprintf(fid,"[CheckBoxes]\n");
  fprintf(fid,"%d\n",CheckBox1->Checked);
  fprintf(fid,"%d\n",CheckBox2->Checked);
  fprintf(fid,"%d\n",CheckBox3->Checked);
  fprintf(fid,"%d\n",CheckBox4->Checked);
  fclose(fid);
}
//---------------------------------------------------------------------------

